#include <stdlib.h>  
#include "os_dectdefs.h"
#include "ccf.h"    
#include "os_mt.h"   
#include "e1_falc2256.h"
#include "mac_delic.h"   
                 
extern enum StatusBreak Stop;
void StopMessage(enum StatusBreak st);
int nb_stop=0x30;
extern struct FALC falc[1];

extern struct TimerReel Timers1;
extern struct TimerReel Timers2;

extern struct DQ MessageQueueL1;  
extern struct DQ MessageQueueL2;  

extern int Line1_L2_Established;
extern int Line2_L2_Established;

void DSS1Lapd_UpProcess(pMessage m);
void Power_forBS(BYTE nb,enum Switching power);   /*power managment for BS*/
void write_power_led(int power,int led);

struct Cell* CellConstructor(int n_bs);
extern struct LcManager* lc_manager;

extern struct DSS1Lapd Lapd[1];   /*lapd for cells*/

extern DWORD current_tick;
extern struct LocalCluster lcs;
extern struct LocalCluster* local_cluster;


void LocalClusterConstructor();     
void TimeOutSlip(ptimer p);  
void PriCell_Send(pMessage m);

/*void Power_forBS(BYTE i, enum Switching power);  */
void Dispatch_UpProcess(pMessage m); 
void InitAllMBC();

/*********************************************************************/

void StoreConstructor()
{
 local_cluster->cells.items=0;
 local_cluster->mbcs.items=0;  
 local_cluster->cells.size=MaxCell;
 local_cluster->mbcs.size=MaxMBC;

/* InitAllMBC();*/
}


/**********************************************/
void InitDect()
{
 LocalClusterConstructor();
}

void Memory_Process(pMessage m);

void LocalCluster_UpProcess(pMessage m)
{
 BOOL dh;
 pMessage mo;
 DWORD dt, sum=0;
 int a, i; 
 int on_off;
 int nb;

 int index;
 
 int l;
 int param;

 l=GetLength(m);

 switch(m->head.ID)
 {            
  case LAPD_DataLoad_Req:
   mo=AllocMessage(LAPD_DataLoad_Req,l);
   CopyMessage(mo,m);

   mo->head.nb=0;
   mo->head.pFunc=Memory_Process;
   put(&MessageQueueL1,(pDQE)mo);
 
   FreeMessage(m);
  return;
	
  case LAPD_Load_Req:
  case LAPD_EndOfFile:
  case LAPD_Start_Req:

  case LAPD_Version_Req:
   mo=AllocMessage(m->head.ID,0);
   mo->head.nb=0;
   mo->head.pFunc=Memory_Process;
   put(&MessageQueueL1,(pDQE)mo);

   FreeMessage(m);
  return;


  default:

   FreeMessage(m);
  return;
   
 }
}
/*****************************************************/
void LocalClusterConstructor()
{
 int i;
 local_cluster=&(lcs);

 StoreConstructor(); 

 for(i=0;i<MaxCell;i++)
     local_cluster->cells.data[i]=NULL;	

}




