#ifndef _OS_ALLTST_H
#define _OS_ALLTST_H

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

#ifndef _OS_MT_H
#include "os_mt.h"
#endif
/*
union Status
{
 BYTE uc;
 struct
 {
  WORD notused:4;

  BOOL SWITI  :1;
  BOOL FALC3  :1;
  BOOL FALC2  :1;
  BOOL OCTAT1  :1;

  BOOL OCTAT0  :1;
  BOOL DELIC  :1;
  BOOL FALC1  :1;
  BOOL FALC0  :1;
  BOOL TstDm  :1;
  BOOL TstPm  :1;
  BOOL ChsumProg :1;
  BOOL ChsumLoader :1;
 }s;
};
*/
#ifdef MBSv1_3

#define BSpower		0
#define TestStatus 	1
#define E1status	2

union MCP23S17_SPI_word
{
 unsigned long uc;
 struct
 {
  BYTE unused:8;
  BYTE cmd:8;
  BYTE reg_addr:8;
  BYTE data:8;
 } s;
};
#endif

union Status
{
 unsigned long uc;
 struct
 {
  WORD unused:8;
  WORD addr:2;

  BOOL unused0:1;
  BOOL unused1:1;
  BOOL unused2:1;
  BOOL unused3:1;
  BOOL unused4:1;
  BOOL unused5:1;
  BOOL unused6:1;
  BOOL unused7:1;

  BOOL FALC1:1;		// status bit for test FALC1
  BOOL DELIC:1;		// status bit for test DELIC
  BOOL OCTAT0:1;	// status bit for test OCTAT0
  BOOL OCTAT1:1;	// status bit for test OCTAT1

  BOOL FALC0  :1;	// status bit for test FALC0
  BOOL ChsumLoader:1;		// status bit for test ChsumLdr
  BOOL ChsumProg:1;	// status bit for test ChsumProg
  BOOL TstMem:1;	// status bit for test Prog
#ifdef MBSv1_3
  BOOL ste11_yellow:1;	// status bit 0 for E1 line 1
  BOOL ste11_red:1;		// status bit 1 for E1 line 1
  BOOL ste11_green:1;	// status bit 2 for E1 line 1
  BOOL ste10_yellow:1;	// status bit 0 for E1 line 0
  BOOL ste10_red:1;		// status bit 1 for E1 line 0
  BOOL ste10_green:1;	// status bit 2 for E1 line 0
#else
  BOOL ste10_green:1;	// status bit 2 for E1 line 0
  BOOL ste10_red:1;		// status bit 1 for E1 line 0
  BOOL ste10_yellow:1;	// status bit 0 for E1 line 0
  BOOL ste11_green:1;	// status bit 2 for E1 line 1
  BOOL ste11_red:1;		// status bit 1 for E1 line 1
  BOOL ste11_yellow:1;	// status bit 0 for E1 line 1
#endif
 }s;
};

extern union Status StatusErr;

#endif
