#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <mem.h>

#include <stdlib.h>
#include "os_mt.h"
#include "os_timer.h"
#include "os_message.h"
#include "mac_delic.h"
#include "e1_falc2256.h"
#include "ccf.h"
#include "os_alltst.h"
#include "rom_pmwr.h"

#define GPIO_GPIO                 (0x0000u)
//#include <csl_gpio.h>
#include "c:\CCStudio_v3.3\MyProjects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"
#include <csl_gpio.h>
#include <csl_dma.h>

extern int TestEnded;
extern SWI_Obj Level0;
extern SWI_Obj Level1;
extern SWI_Obj Level2;
extern SWI_Obj Leveln;

extern LOG_Obj MacTrace;
extern BYTE MessageBalance;

int StatusOut;

extern int nb_stop;
extern struct Message MessageArray[MESSAGE_ARRAY_SIZE];

int LoadProgram=50;

void OutputGPIO(int data);
/*
char length_error[]="length error";
char lapd_release[]="LAPD RELEASE INDICATION" ;
char rxi_stack[]="RXI STACK CORRUPTED" ;
char mess_stack[]="MESSAGE STACK CORRUPTED" ;
char flag_stack[]="FLAG STACK CORRUPTED" ;
char func_pntr[]="FUNCTION POINTER=0" ;
char pcm_error[]="PCM CHANNEL ERROR" ;
char timer_error[]="TIMER AUDIT ERROR" ;
char ci_error[]="CI CHANGE ERROR" ;
char isac_error[]="ISAC ERROR" ;
char sector_error[]="FLASH SECTOR NUMBER ERROR" ;
char all_right[]="ALL RIGHT" ;

char ccf_stack[]="CCF STACK CORRUPTED" ;
char ident_stack[]="CH_IDENTITY STACK CORRUPTED" ;
char bmc_stack[]="BMC STACK CORRUPTED" ;
char delic_stack[]="DELIC STACK CORRUPTED" ;
char upch_stack[]="Up STACK CORRUPTED" ;

char err_lapdnb[]="LAPD NUMBER ERROR" ;
char err_linenb[]="LINE NUMBER ERROR" ;
char err_pcmslotnb[]="PCM_SLOT NUMBER ERROR" ;
char err_structnb[]="STRUCTURE NUMBER ERROR" ;

char err_mbcfind[]="NO SUCH MBC" ;
char err_delicboot[]="DELIC BOOT FAILED" ;
char err_deliccmd[]="DELIC CMD FAILED" ;
char err_delicmon[]="DELIC MONITOR_CH FAILED" ;
char err_delicswtch[]="DELIC SWITCH ID>FF FAILED" ;
char err_delichdlc[]="DELIC HDLC ERROR" ;
char err_falc[]="FALC ERROR" ;

char err_mess[]="NO SUCH MESSAGE ID" ;
char err_linkest[]="SABME FROM LINE 7F(GHDLC)" ;
char err_mbctimer[]="MBC TIMER IN ILLEGAL STATE" ;
char err_mbcbearer[]="MBC MAIN_BEARER=0 IN HO" ;
char err_mbcdelete[]="MBC INCORRECT DELETE" ;
char err_mbcswitch[]="MBC pIdIn != pIdOut" ;
char err_mbctxlngth[]="MBC WRONG TX LENGTH" ;
char err_mbctxfrm[]="MBC TX FRAME !=0" ;
char err_mbc1mess[]="MBC ILLEGAL FIRST MSG" ;
char err_errmbclink[]="NO LINK FOR MBC_NewLcMess" ;
char err_errmbcpcmid[]="ATTEMPT CONNECT TO pID !=0" ;

char err_infodst[]="BEARER DATA TO NOWHERE" ;
char err_errcellbr[]="NO SUCH BEARER OR MBC" ;
*/
/*
char lapd_release[]="LAPD RELEASE INDICATION_l" ;
char rxi_stack[]="RXI STACK CORRUPTED_l" ;
char mess_stack[]="MESSAGE STACK CORRUPTED_l" ;
char flag_stack[]="FLAG STACK CORRUPTED_l" ;
char func_pntr[]="FUNCTION POINTER=0_l" ;
char pcm_error[]="PCM CHANNEL ERROR_l" ;
char timer_error[]="TIMER AUDIT ERROR_l" ;
char ci_error[]="CI CHANGE ERROR_l" ;
char isac_error[]="ISAC ERROR_l" ;
char sector_error[]="FLASH SECTOR NUMBER ERROR_l" ;
char all_right[]="ALL RIGHT_l" ;

char ccf_stack[]="CCF STACK CORRUPTED_l" ;
char ident_stack[]="CH_IDENTITY STACK CORRUPTED_l" ;
char bmc_stack[]="BMC STACK CORRUPTED_l" ;
char delic_stack[]="DELIC STACK CORRUPTED_l" ;
char upch_stack[]="Up STACK CORRUPTED_l" ;

char err_lapdnb[]="LAPD NUMBER ERROR_l" ;
char err_linenb[]="LINE NUMBER ERROR_l" ;
char err_pcmslotnb[]="PCM_SLOT NUMBER ERROR_l" ;
char err_structnb[]="STRUCTURE NUMBER ERROR_l" ;

char err_mbcfind[]="NO SUCH MBC_l" ;
char err_delicboot[]="DELIC BOOT FAILED_l" ;
char err_deliccmd[]="DELIC CMD FAILED_l" ;
char err_delicmon[]="DELIC MONITOR_CH FAILED_l" ;
char err_delicswtch[]="DELIC SWITCH ID>FF FAILED_l" ;
char err_delichdlc[]="DELIC HDLC ERROR_l" ;
char err_falc[]="FALC ERROR_l" ;

char err_mess[]="NO SUCH MESSAGE ID_l" ;
char err_linkest[]="SABME FROM LINE 7F(GHDLC)_l" ;
char err_mbctimer[]="MBC TIMER IN ILLEGAL STATE_l" ;
char err_mbcbearer[]="MBC MAIN_BEARER=0 IN HO_l" ;
char err_mbcdelete[]="MBC INCORRECT DELETE_l" ;
char err_mbcswitch[]="MBC pIdIn != pIdOut_l" ;
char err_mbctxlngth[]="MBC WRONG TX LENGTH_l" ;
char err_mbctxfrm[]="MBC TX FRAME !=0_l" ;
char err_mbc1mess[]="MBC ILLEGAL FIRST MSG_l" ;
char err_errmbclink[]="NO LINK FOR MBC_NewLcMess_l" ;
char err_errmbcpcmid[]="ATTEMPT CONNECT TO pID !=0_l" ;

char err_infodst[]="BEARER DATA TO NOWHERE_l" ;
char err_errcellbr[]="NO SUCH BEARER OR MBC_l" ;
*/

char sector_error[]="FLASH SECTOR NUMBER ERROR" ;

char length_error[]="length error";
char lapd_release[]="LAPD RELEASE INDICATION" ;
char mess_stack[]="MESSAGE STACK CORRUPTED" ;
char flag_stack[]="FLAG STACK CORRUPTED" ;
char func_pntr[]="FUNCTION POINTER=0" ;
char pcm_error[]="PCM CHANNEL ERROR" ;
char timer_error[]="TIMER AUDIT ERROR" ;
char ci_error[]="CI CHANGE ERROR" ;
char all_right[]="ALL RIGHT" ;

char ident_stack[]="CH_IDENTITY STACK CORRUPTED" ;
char delic_stack[]="DELIC STACK CORRUPTED" ;
char upch_stack[]="Up STACK CORRUPTED" ;

char err_lapdnb[]="LAPD NUMBER ERROR" ;
char err_linenb[]="LINE NUMBER ERROR" ;
char err_pcmslotnb[]="PCM_SLOT NUMBER ERROR" ;
char err_pcmportnb[]="PCM_PORT NUMBER ERROR" ;
char err_structnb[]="STRUCTURE NUMBER ERROR" ;

char err_delicboot[]="DELIC BOOT FAILED" ;
char err_deliccmd[]="DELIC CMD FAILED" ;
char err_delicmon[]="DELIC MONITOR_CH FAILED" ;
char err_delichdlc[]="DELIC HDLC ERROR" ;
char err_falc[]="FALC ERROR" ;

char err_mess[]="NO SUCH MESSAGE ID" ;
char err_linkest[]="SABME FROM LINE 7F(GHDLC)" ;

char ind_pool_err[]="indication pool error" ;
char cmd_pool_err[]="command pool error" ;

char err_test[]="error timeout test" ;

char err_LengthString[]="length string > 30" ;

char test_falc1_f[]="Test result: FALC1 not present";
char test_falc2_f[]="Test result: FALC2 not present";
char test_delic_f[]="Test result: DELIC not present";
char test_octat1_f[]="Test result: OCTAT1 not present";
char test_octat2_f[]="Test result: OCTAT2 not present";

char test_falc1_g[]="Test result: FALC1 initialized";
char test_falc2_g[]="Test result: FALC2 initialized";
char test_delic_g[]="Test result: DELIC initialized";
char test_octat1_g[]="Test result: OCTAT1 initialized";
char test_octat2_g[]="Test result: OCTAT2 initialized";
char test_end[]="Test result: EndTesting ";

void Delic_DnProcess();

extern int ReadHPI;
extern int PreviousLevelWD;
void resetWD();
int TrafficLight=50;

extern struct LcManager* lc_manager;
extern struct LocalCluster* local_cluster;

extern int* pntrLine1;
extern int DataLine1;
extern int* pntrLine2;
extern int DataLine2;

extern int Line1_L2_Established;
extern int Line2_L2_Established;
extern int FalcError1;	/*0 - ok, 1 - AIS,LFA,LMFA,CRC4, 2 - RA */
extern int FalcError2;	/*0 - ok, 1 - AIS,LFA,LMFA,CRC4, 2 - RA */

extern unsigned long addr_flash_dst;

extern union Status StatusErr;     /*status after testing hardware*/
enum StatusBreak Stop;
void StatusWrite();
void SetFalcState();


void (*pFuncProc)(struct Message* mo);   /*pointer to message processor*/
void (*pTimProc)(struct Timer* t);   	 /*pointer to timer processor*/
void (*pFlagProc)(struct FlagMessage* fo);   /*pointer to flag processor*/
ptimer TimerReelGetExpired();
struct DQ MessageQueueL1;
struct DQ MessageQueueL2;
struct DQ FlagQueue;

extern struct TimerReel Timers1;
extern struct TimerReel Timers2;

struct VN_type VersNumber;   /*version number xx.xx */

DWORD current_tick=0;

void InitCSF();		/* cell site function*/
void InitMCP();
void MCP_write(BYTE type);

/***************flag functions***********************************/
struct FlagMessage FlagArray[FLAG_ARRAY_SIZE];
struct DQ FlagStack;

extern struct DQ ind_pool;
extern struct DQ cmd_pool;
extern struct DQ DelicCmd;
extern struct DQ DelicInd;
extern struct DelicMailboxInfo DelicCmdArray[BUFSIZE_DELIC_CMD];
extern struct DelicMailboxInfo DelicIndArray[BUFSIZE_DELIC_IND];
void putDelicCmd(pDQE e);
pDQE getDelicCmd();
void putDelicInd(pDQE e);
pDQE getDelicInd();

void FreeInd(pDelicInfo Id);
pDelicInfo GetInd();
void FreeCmd(pDelicInfo Id);
pDelicInfo GetCmd();

void StopMessage(enum StatusBreak st);

extern union DELIC* dlc;	/*for example!!!*/
int DelicReady=0;

int FlagServiceFalc=0;
int PeriodFalcService=0;

int Flag2ms=0;
int FlagTest=1;

void DelicProcessing()
{
 pDelicInfo pInd;
 pDelicInfo pCmd;
 enum ind_delic indication;
 enum cmd_delic command;
 union DELIC* dlc;

 int i, HdlcNb, length=0, ErrCode, stat1;

/*read status delic for reading and read status for writing*/
/*if mailbox on read not empty, reading and send indication to Delic DnProcess or
  rewrite this indication to temporarily buffer for read(from DSP side)*/
/*  
 if temporarily buffer for write(from DSP side) is not empty - write this data
 to delic  
*/
/*produce time slice for work with FalcDnProcess(control L1(physical layer))*/
/*information across mailbox(hdlc info(IOM,PCM), monitor info for initialize OCTAT,
  CI info Up layer 1 state machine*/

 SWI_disable();

 current_tick++;

 if(DelicReady==0)
 {
  if(++PeriodFalcService>=TIME_SERVICE)
  {
   PeriodFalcService=0;
   FlagServiceFalc=TRUE;
  }
  SWI_enable();
  SWI_post(&Level0);
  return;
 }
 
 dlc=(union DELIC*)BASE_DELIC1;		/*addr delic chip1*/

 if((dlc->r.obusy)&0x80)     /*ready for read indication*/
 {
  pInd=GetInd();
  indication=(dlc->r.ocmd)&0xff;

  switch(indication)
  {
/*HDLC indications*/
   case  ReceiveHdlc:		/*RME*/    /*-OGENL=HDLC nb, OGENH=Size,ODTx=Data*/
   case  ReceiveContinuousHdlc:	/*RPF*/  /*-OGENL=HDLC nb, OGENH=Size,ODTx=Data*/
    
    length=(dlc->r.ogenh)&0x3f;	/*length*/
    HdlcNb=(dlc->r.ogenl)&0x1f;	/*32 hdlc*/


    pInd->Addr=HdlcNb;
    pInd->length=length;
    if(indication==ReceiveHdlc)
     pInd->type=ReceiveHdlc;
    else
     pInd->type=ReceiveContinuousHdlc;
   
    for(i=0;i<length;i++)
    {
     pInd->data[i]=(dlc->r.odtx[i])&0xff;
    } 

	break;
  
   case  TransmitReadyHdlc:		/*-OGENL=HDLC nb*/

    HdlcNb=(dlc->r.ogenl)&0x1f;	/*32 hdlc*/

    pInd->Addr=HdlcNb;
    pInd->length=0;
    pInd->type=TransmitReadyHdlc;
	break;
  
   case  ErrorHdlc:				/*-OGENL=HDLC nb, OGENH=0x01, ODT0L=ErrorCode*/

    HdlcNb=(dlc->r.ogenl)&0x1f;	/*32 hdlc*/
    ErrCode=(dlc->r.odtx[0])&0xff;

	pInd->Addr=HdlcNb;
	pInd->length=1;
    pInd->type=ErrorHdlc;
    pInd->data[0]=ErrCode;
	break;

/*IOM2*/  
   case  ChangeDetected:			/*OGENH=Size,ODTx=IOM2 port and Ch,new CI value*/
    length=(dlc->r.ogenh)&0x1f;	/*length*/
	pInd->length=length;

    for(i=0;i<length;i++)
    {
     pInd->data[i*2]=(dlc->r.odtx[i*2])&0xff;		/*subscriber addr(port,ch)*/
     pInd->data[i*2+1]=(dlc->r.odtx[i*2+1])&0xff;	/*CI value*/
    }
	pInd->type=ChangeDetected;
	break;

/*IOM2 monitor indications*/
   case  ReceiveMon:				/*-OGENH=Size,ODTx=Data*/
   case  ReceiveContinuousMon:	/*-OGENH=Size,ODTx=Data*/

    length=(dlc->r.ogenh)&0x3f;	/*amount of valid entry*/
    length=2;	/*amount of valid entry*/
    pInd->length=length;

    for(i=0;i<length;i++)
    {
     pInd->data[i]=(dlc->r.odtx[i])&0xff;		/*data block*/
    }
	pInd->type=indication;
	pInd->Addr=0;
   	break;

   case  TransferReadyMon:
   case  TransmitAbortMon:

    pInd->length=0;
	pInd->type=indication;
   	break;

   case  MonitorActive:			/*-OGENL=IOM2 port and Ch*/

    pInd->length=1;
    pInd->data[0]=(dlc->r.ogenl)&0xf;	/*IOM2 port and ch*/
	pInd->type=indication;
   	break;

/*Error indication*/
   case  QueueOverflow:			/*microprocessor was too slow to read mailbox */
   case  CommandError:			/*invalid cmd from microprocessor*/
		  
    pInd->length=0;
	pInd->type=indication;
   	break;

   case  ReadRegInd:				/*-OGENL=Size,ODT0-15 Values read from register*/

    length=(dlc->r.ogenl)&0x1f;	/*amount of valid entry*/
    pInd->length=length;

    for(i=0;i<length;i++)
    {
     pInd->data[i*2]=(dlc->r.odtx[i*2])&0xff;		/*data block*/
     pInd->data[i*2+1]=(dlc->r.odtx[i*2+1])&0xff;	/*data block*/
    }
	pInd->type=indication;
   	break;
 
   default:
	StopMessage(Delic_error);
   	break;
  
  }
  dlc->w.obusy=0;				/*reset obusy, for order to release the mailbox*/

  putDelicInd((pDQE)pInd);

 }
 
 if(DelicCmd.items) /*queue not empty!!!*/
 {
  if(((dlc->r.mbusy)&0x80)==0)       /*ready for write cmd*/
  {
   pCmd=(pDelicInfo)getDelicCmd();
   command=pCmd->type;
   length=pCmd->length;

   switch(command)
   {
/*HDLC channel*/
    case   TransmitContinuousHdlc:/*-MGENL=HDLC nb,MGENH=Size,MDTx=Data*/
    case   TransmitHdlc:		/*-MGENL=HDLC nb,MGENH=Size,MDTx=Data*/

     dlc->w.mgenl=pCmd->Addr;    	  /*addr of hdlc*/
     dlc->w.mgenh=length;

     for(i=0;i<length;i++)
     {
      dlc->w.mdtx[i]=pCmd->data[i];
     } 
     dlc->w.mcmd=command;
     break;

    case   ResetHdlc:			/*-MGENH=Size,MDTx=HDLC nb*/
     dlc->w.mgenh=length;    	    /*amount of hdlc !=1 */
     for(i=0;i<(length);i++)
     {
      dlc->w.mdtx[i]=pCmd->data[i];
     } 

     dlc->w.mcmd=command;    	/* reset hdlc(1...8 , 2 bytes per entry,mdt[i] low)*/
	 break;

    case   ActivDeactivHdlc:	/*-MGENH=Size,MDTx=HDLC nb and activation info*/

     dlc->w.mgenh=length;    	    /*amount of hdlc !=1 */
     for(i=0;i<(length);i++)
     {
      dlc->w.mdtx[i]=pCmd->data[i];
     } 

     dlc->w.mcmd=command;    	/* activate hdlc(1...16 , 1 byte per entry)*/

     break;


/*IOM2 monitor channel*/

    case   TransmitMon:				/*-MGENL=IOM2 port and Ch,MGENH=Size,MDTx=Data*/
    case   TransmitContinuousMon:	/*-MGENL=IOM2 port and Ch,MGENH=Size,MDTx=Data*/
    case   TrRec_ReceiveOnly:		/*if size=0 -receive only command*/

     for(i=0;i<length;i++)
     {
      dlc->w.mdtx[i]=pCmd->data[i];
     }
     dlc->w.mgenl=pCmd->Addr;
     dlc->w.mgenh=length;

     dlc->w.mcmd=command;
 	 break;

    case   SearchOn:
    case   SearchReset:
    case   MonitorReset:
     dlc->w.mcmd=command;
     break;
 
/*read/write register*/
    case   WriteReg:			/*-MGENL=Size,MDT0=DestinationAddr,MDT1-15=Data*/
 
     dlc->w.mdtx[0]=pCmd->Addr;		/*high part of addr*/
     dlc->w.mdtx[1]=(pCmd->Addr)>>8;	/*low part of addr*/
	 dlc->w.mdtx[2]=pCmd->data[0];     /*high part of data*/
	 dlc->w.mdtx[3]=pCmd->data[1];		/*low part of data*/

	 dlc->w.mgenl=length;    	 /*nbr of words to read*/
	 dlc->w.mgenh=0;

     dlc->w.mcmd=command;
     break;

    case   ReadRegCmd:		    /*-MGENL=Size,MDT0=StartAddr for read*/
 
     dlc->w.mdtx[0]=pCmd->Addr;		/*high part of addr*/
     dlc->w.mdtx[1]=(pCmd->Addr)>>8;	/*low part of addr*/

	 dlc->w.mgenl=length;    	 /*nbr of words to read*/
	 dlc->w.mgenh=0;

     dlc->w.mcmd=command;
     break;
 
/*IOM2 CI command*/ 
    case   WriteCI:				/*-MGENH=Size,MDTx=IOM2 port and Ch, CI value*/
 	 dlc->w.mgenl=0; 
 	 dlc->w.mgenh=length;		/*amount of valid entry*/
     for(i=0;i<length;i++)
     {
      dlc->w.mdtx[i*2]=pCmd->data[i*2];		/*subscriber addr(port,ch)*/
      dlc->w.mdtx[i*2+1]=pCmd->data[i*2+1];	/*CI value*/
     }
     dlc->w.mcmd=command;
     break;

    default:
	 StopMessage(Delic_error);
     break;
   }
   FreeCmd(pCmd);
  }
 }
 
 if(++PeriodFalcService>=TIME_SERVICE)
 {
  PeriodFalcService=0;
  FlagServiceFalc=TRUE;
 }
 
 SWI_enable();
 SWI_post(&Level0);
}


void initFlagStack()
{
 int i;
 initDQ(&FlagStack);
 for(i=0;i<FLAG_ARRAY_SIZE;i++)
  put(&FlagStack,(pDQE)(&(FlagArray[i])));
}

void FreeFlag(pFlag f)
{
 HWI_disable();
 if(FlagStack.items>=FLAG_ARRAY_SIZE)
     StopMessage(FLAG_stack);

 if(FlagStack.items)
  put(&FlagStack,(pDQE)f);

 HWI_enable();
}

pFlag AllocFlag(enum MessageID mid)
{
 pFlag fa;
 if(FlagStack.items==1)
  StopMessage(FLAG_stack);

 fa=(pFlag)get(&FlagStack);
 if(fa<(pFlag)&FlagArray[0] || fa>(pFlag)&FlagArray[FLAG_ARRAY_SIZE-1])
  StopMessage(FLAG_stack);
 fa->ID=mid;
 return fa;
}
/***************flag functions***********************************/


void StopMessage(enum StatusBreak st)
{
/**********write**********************/
 int* pntr_mess;
 char* pntr;
 int i, symbol, length=0;

 falc[0].chip->w.fmr1.s.xais=1;
 HWI_disable();

 addr_flash_dst=(unsigned long)0x0000f0000u;/*sector f*/
 
 switch(st)
 {
  case  FALC:
   pntr=err_falc;
  break;
  case  LAPD_RelInd:
   pntr=lapd_release;
  break;

  case  MESS_stack:
   pntr=mess_stack;
  break;
  case  FLAG_stack:
   pntr=flag_stack;
  break;
  case  FUNC_pntr:
   pntr=func_pntr;
  break;
  case  TimerAudit:
   pntr=timer_error;
  break;

  case  CI_change:
   pntr=ci_error;
  break;
  case  Delic_stack:
   pntr=delic_stack;
  break;
  case  Delic_boot:
   pntr=err_delicboot;
  break;
  case  Delic_error:
   pntr=err_deliccmd;
  break;
  case  Delic_monitor:
   pntr=err_delicmon;
  break;
  case  Delic_hdlc:
   pntr=err_delichdlc;
  break;

  case  ErrLapdNb:
   pntr=err_lapdnb;
  break;
  case  ErrLineNb:
   pntr=err_linenb;
  break;
  case  ErrLinkEst:
   pntr=err_linkest;
  break;

  case  IDENT_stack:
   pntr=ident_stack;
  break;

  case  ErrStructNb:
   pntr=err_structnb;
  break;
  
  case  ErrMess:
   pntr=err_mess;
  break;
  case  ErrLength:
   pntr=length_error;
  break;

  case  ind_pool_st:
   pntr=ind_pool_err;
  break;
  case  cmd_pool_st:
   pntr=cmd_pool_err;
  break;

  case  ErrTest:
   pntr=err_test;
  break;

  case  AllRight:
   pntr=all_right;
  break;

  case ErrorSectorNumber:
   pntr=sector_error;
  break;

  default:
  return;
 }

 for(i=0;i<30;i++) //write string (status before  B $)
 {
  symbol=*pntr++;
  if(symbol==0)
   break;
  prog_enhanced_value(addr_flash_dst,symbol,0);//write byte
  addr_flash_dst++;
 }

 if(Stop==ErrMess || Stop==MESS_stack)
 {
  prog_enhanced_value(addr_flash_dst,0x20,0);//write byte
  addr_flash_dst++;
  prog_enhanced_value(addr_flash_dst,nb_stop,0);//write byte
  addr_flash_dst++;

 }
 prog_enhanced_value(addr_flash_dst,symbol,0);//write byte

/**********write**********************/
 asm(" B $ ");
}


void falc_service()
{
 pFlag fo;
 int nb;

 BYTE gis;

 union FALC_ISR0 i0;
 union FALC_ISR1 i1;
 union FALC_ISR2 i2;
 union FALC_ISR3 i3;
 union FALC_ISR4 i4;
 union FALC_ISR5 i5;

/*flags for falc!!!*/
nb=0;
  
   if(falc[nb].state<NotInit)
   {
    gis=falc[nb].chip->r.gis;
    if(gis&1)
    {		/* isr0*/
     i0.uc=(falc[nb].chip->r.isr0.uc)&0xff;
     if(i0.s.rfs)
     {
      fo=AllocFlag(FALC_RFS);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i0.s.crc4)
     {
      fo=AllocFlag(FALC_CRC4);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i0.s.rme)
     {
      fo=AllocFlag(FALC_RME);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i0.s.rpf)
     {
      fo=AllocFlag(FALC_RPF);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
    }

    if(gis&2)
    {		/* isr1*/
     i1.uc=(falc[nb].chip->r.isr1.uc)&0xff;

     if(i1.s.rdo)
     {
      fo=AllocFlag(FALC_RDO);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i1.s.alls)
     {
      fo=AllocFlag(FALC_ALLS);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
/********************************************/
   if(i1.s.xdu)
   {
    if(i1.s.xpr)
    {
     fo=AllocFlag(FALC_XDU_XPR);
     fo->chip_nbr=nb;
     fo->pFunc=Falc_DnProcess;
     put(&FlagQueue,(pDQE)fo);
    }
    else
    {
     fo=AllocFlag(FALC_XDU);
     fo->chip_nbr=nb;
     fo->pFunc=Falc_DnProcess;
     put(&FlagQueue,(pDQE)fo);
    }
   }
   else
   {
    if(i1.s.xpr)
    {
     fo=AllocFlag(FALC_XPR);
     fo->chip_nbr=nb;
     fo->pFunc=Falc_DnProcess;
     put(&FlagQueue,(pDQE)fo);
    }
   }
/********************************************/

/*
     if(i1.s.xdu)
     {
      fo=AllocFlag(FALC_XDU);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i1.s.xpr)
     {
      fo=AllocFlag(FALC_XPR);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
*/    
    }

    if(gis&4)
    {		/* isr2*/
     i2.uc=(falc[nb].chip->r.isr2.uc)&0xff;

     if(i2.uc&0xef)  /* excluding T400ms*/
     {
      fo=AllocFlag(FALC_L1);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
    }

    if(gis&8)
    {		/* isr3*/
     i3.uc=(falc[nb].chip->r.isr3.uc)&0xff;
/*
     if(i3.s.api)
     {
      fo=AllocFlag(FALC_API);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
*/
     if(i3.s.rsn)
     {
      fo=AllocFlag(FALC_RSN);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i3.s.rsp)
     {
      fo=AllocFlag(FALC_RSN);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
    }


    if(gis&0x10)
    {		/* isr4*/
     i4.uc=(falc[nb].chip->r.isr4.uc)&0xff;
     if(i4.s.xsp)
     {
      fo=AllocFlag(FALC_XSP);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
     if(i4.s.xsn)
     {
      fo=AllocFlag(FALC_XSN);
      fo->chip_nbr=nb;
      fo->pFunc=Falc_DnProcess;
      put(&FlagQueue,(pDQE)fo);
     }
    }
   }
 /*read falc status and send flag to FalcDnProcess(process only L1 level(physical))*/
}

void MacLayerLow()
{
 SWI_disable();

 if(FlagServiceFalc)
 {
  FlagServiceFalc=FALSE;
  falc_service();

  TimerReelTick();
 }
/*all timer tics with discrete value=1 ms, recalculate initialization all Timers */

 Delic_DnProcess();			/*process HDLCs,CI change,MON channel*/

 if(MemProc.state!=DataReceive)
   LoadProgram=50;

 SWI_enable();
 SWI_post(&Level1);
} 

void MacLayerHigh()
{
 pMessage mo;
 ptimer t;
 pFlag fo;
 
 SWI_disable();

 if(FlagQueue.items)
 {
  fo=(pFlag)get(&FlagQueue);
  if(fo>=(pFlag)&FlagArray[0] && fo<(pFlag)&FlagArray[FLAG_ARRAY_SIZE])
  {
   if(fo->pFunc)
   {
    pFlagProc=fo->pFunc;
    pFlagProc(fo);
   }
   else
     StopMessage(FUNC_pntr);
  }
  else                                                 
  {
   nb_stop='k';
    StopMessage(MESS_stack);
  }  
 }     /*call function Dn Process (PH - layer)*/

 SWI_enable();
 asm(" nop "); asm(" nop "); asm(" nop "); asm(" nop ");
 SWI_disable();

 if(MessageQueueL1.items)
 {
  mo=getMessage(&MessageQueueL1);
  if(mo<(pMessage)&MessageArray[0] || mo>(pMessage)&MessageArray[MESSAGE_ARRAY_SIZE-1])
  {
   nb_stop='l';
    StopMessage(MESS_stack);
  }
  if(mo->head.pFunc)
  {
   pFuncProc=mo->head.pFunc;
   pFuncProc(mo);
  }
  else
     StopMessage(FUNC_pntr);
 }/*processing messages L1 layer*/ /*call function layer1 UpDn Process*/

 SWI_enable();
 asm(" nop "); asm(" nop "); asm(" nop "); asm(" nop ");
 SWI_disable();

 t=TimerReelGetExpired(&Timers1);

 if(t!=NULL)
 {
  TimerStop(t,&Timers1);
  if(t->pFunc)
  {
   pTimProc=t->pFunc;
   pTimProc(t);
  }
 }/*processing timers L1 layer*/

 SWI_enable();
 SWI_post(&Level2);
}

void DataLink()
{
 pMessage mo;
 ptimer t;

 SWI_disable();
 if(MessageQueueL2.items)
 {
  mo=getMessage(&MessageQueueL2);
  if(mo<(pMessage)&MessageArray[0] || mo>(pMessage)&MessageArray[MESSAGE_ARRAY_SIZE-1])
  {
   nb_stop='m';
    StopMessage(MESS_stack);
  }
  
  if(mo->head.pFunc)
  {
   pFuncProc=mo->head.pFunc;
   pFuncProc(mo);
  }
  else
     StopMessage(FUNC_pntr);
 }/*processing messages L2 layer*/ /*call function layer2 UpDn Process*/
 
 SWI_enable();
 asm(" nop "); asm(" nop "); asm(" nop "); asm(" nop ");
 SWI_disable();

 t=TimerReelGetExpired(&Timers2); /*for layer2*/

 if(t!=NULL)
 {
  TimerStop(t,&Timers2);
  if(t->pFunc)
  {
   pTimProc=t->pFunc;
   pTimProc(t);         /*call to TimeOut*/
  }
 }/*processing timers L2 layer*/

 SWI_enable();
 SWI_post(&Leveln);
}

void OutputHyperTerm()
{
 SWI_disable();
 resetWD();
 SWI_enable();
}

/********************************************/

int ConvertUchToPcmTS(struct BearerInfo b);
void Disconnect4(int InSlot, int InLine, int OutSlot, int OutLine, int cmd);
void Connect4(int InSlot, int InLine, int OutSlot, int OutLine);
 
void DSS1Lapd_UpProcess(struct Message* m);

struct Timer TimerTesting;
struct Timer TimerHeap;
struct Timer Timer02sec1;	/*light 0.2 sec for CRC4,AIC,LFA,LMFA*/
struct Timer Timer03sec1;	/*light 0.2 sec for CRC4,AIS,LFA,LMFA*/

int cntr_1sec=0;

void TimeOutTesting(ptimer t)
{
 int nb=t->nb;

 if(t==&TimerTesting && (nb==0))
  StopMessage(TimerAudit);
}


extern ioport int *portGPIO;
extern struct MemoryProcess MemProc;
 
void TimeOutHeap(ptimer t)
{
 int i,j, param, GPIO_value, nb=t->nb;

 if(t==&TimerHeap && (nb==0))
 {
  //cntr_1sec^=1;
  cntr_1sec=(++cntr_1sec)&0x7;
  
  TimerStart(&TimerHeap,&Timers1);

  portGPIO=(ioport int*)0x00003401; 
  GPIO_value=(*portGPIO)&0xff;

 if( (lc_manager->lce.DatalinkState)==LinkEstablished )
 {
  if(MemProc.state==DataReceive)
   {
    if(!(cntr_1sec & 0x1))
     *portGPIO=GPIO_value^0x80;
   }
  else
  {
   if(!(cntr_1sec & 0x3))
    *portGPIO=GPIO_value^0x80;
  }
 }
 else
  if(!cntr_1sec)
   *portGPIO=GPIO_value | 0x80;
  else
   *portGPIO=GPIO_value & 0x7F;   

 if((cntr_1sec == 0) || (cntr_1sec == 4))
  {
/***************GREEN LED for LINE1*******************************/
 if(Line1_L2_Established)
  StatusErr.s.ste10_green=1;	/*switch on 1 green LED*/
 else
 {
  if(falc[0].state==FalcSync)
   StatusErr.s.ste10_green^=1;
  else
   StatusErr.s.ste10_green=0;	/*switch off 1 green LED*/
 }
/***************GREEN LED for LINE1*******************************/

/***************RED LED for LINE1*******************************/

  if(falc[0].fault_id==LOS)
  {
   FalcError1=0;
   StatusErr.s.ste10_red=1;
  }
  else
  {
   if(falc[0].fault_id==RA)
   {
    if(cntr_1sec)
    {
     StatusErr.s.ste10_red^=1;
     FalcError1=0;
    }
   }
  }
  if(falc[0].fault_id==line_ok)
  {
   FalcError1=0;
   StatusErr.s.ste10_red=0;
  }

/***************RED LED for LINE1*******************************/

/***************YELLOW LED for LINE1****************************/
  if((falc[0].fault_id==LFA) || (falc[0].fault_id==LMFA))
  {
   StatusErr.s.ste10_yellow^=1;	/*blinking 1 yellow LED*/
   TimerStop(&Timer03sec1,&Timers1);
   TimerStart(&Timer03sec1,&Timers1);
  }
  if(falc[0].fault_id==AIS)
  {
   StatusErr.s.ste10_yellow=1;	/*switch on 1 yellow LED*/
   TimerStop(&Timer03sec1,&Timers1);
   TimerStart(&Timer03sec1,&Timers1);
  }
  if(FalcError1)
  {
   StatusErr.s.ste10_yellow^=1;	// blinking 1 yellow LED
   TimerStop(&Timer03sec1,&Timers1);
   TimerStart(&Timer03sec1,&Timers1);
   FalcError1=0;
  }
  
  if(falc[0].fault_id==line_ok)
  {
   TimerStop(&Timer03sec1,&Timers1);
   StatusErr.s.ste10_yellow=0;	/*switch off 1 yellow LED*/
  }
/***************YELLOW LED for LINE1****************************/
  
  if(t==&Timer02sec1)
   StatusErr.s.ste10_red=0; 	/*switch off 1 red LED*/

  if(t==&Timer03sec1)
   StatusErr.s.ste10_yellow=0;		/*switch off 1 yellow LED*/

#ifdef MBSv1_3
  MCP_write(E1status);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif
  }
 }
}


void TestMem();
int read_status();

void main()
{
 int i,j,k,x, param, size=0;
 ptimer t;
 int* pntr_load;
 int* pntr_run;

 CSL_init();
 cslCfgInit();

 HWI_disable();

// GPIO_pinEnable (GPIO_PIN0);
// GPIO_pinEnable (GPIO_PIN1);
// GPIO_pinEnable (GPIO_PIN2);
// GPIO_pinEnable (GPIO_PIN3);
// GPIO_pinEnable (GPIO_PIN4);
// GPIO_pinEnable (GPIO_PIN5);
// GPIO_pinEnable (GPIO_PIN6);
// GPIO_pinEnable (GPIO_PIN7);
 GPIO_pinDirection(GPIO_PIN0, GPIO_OUTPUT);
 GPIO_pinDirection(GPIO_PIN1, GPIO_OUTPUT );
 GPIO_pinDirection(GPIO_PIN2, GPIO_OUTPUT );
 GPIO_pinDirection(GPIO_PIN3, GPIO_OUTPUT );
 GPIO_pinDirection(GPIO_PIN4, GPIO_OUTPUT);
 GPIO_pinDirection(GPIO_PIN5, GPIO_OUTPUT);
 GPIO_pinDirection(GPIO_PIN6, GPIO_INPUT);
 GPIO_pinDirection(GPIO_PIN7, GPIO_OUTPUT);

 GPIO_pinWrite(GPIO_PIN0, 0);
 GPIO_pinWrite(GPIO_PIN1, 0);
// GPIO_pinWrite(GPIO_PIN2, 0);	//master =1, slave =0
 GPIO_pinWrite(GPIO_PIN2, 1);	//master =1, slave =0
 GPIO_pinWrite(GPIO_PIN3, 1);
 GPIO_pinWrite(GPIO_PIN4, 1);
 GPIO_pinWrite(GPIO_PIN5, 0);
 GPIO_pinWrite(GPIO_PIN7, 0);
    for(j=0;j<0xf000;j++)
	{
     k++;
	 i=i+k;
	 i=3*k;
	}

 GPIO_pinWrite(GPIO_PIN0, 1);
 GPIO_pinWrite(GPIO_PIN1, 0);
// GPIO_pinWrite(GPIO_PIN2, 0);
 GPIO_pinWrite(GPIO_PIN2, 1);
 GPIO_pinWrite(GPIO_PIN3, 1);
 GPIO_pinWrite(GPIO_PIN4, 1);
 GPIO_pinWrite(GPIO_PIN5, 0);
 GPIO_pinWrite(GPIO_PIN7, 1);

//Start loader_TOP:
 pntr_load=(int*)0x3800;
 pntr_run=(int*)0x7400;
/*
 for(i=0;i<0x400;i++)
 {
  param=*pntr_load++;
  *pntr_run++=param;
 }
*/
End_loader_TOP:

 MCBSP_start(hMcbsp0,MCBSP_XMIT_START|MCBSP_RCV_START|MCBSP_SRGR_START/*|
	 					MCBSP_SRGR_FRAMESYNC*/,0x300);
 write_enable();

//k=read_status();

// addr_flash_dst=(unsigned long)0x0000e0003u;
// prog_enhanced_value(addr_flash_dst,0x5678,1);

 addr_flash_dst=(unsigned long)0x0000e0003u;
 VersNumber.uc[0]=ReadFlashData(addr_flash_dst,0);

 addr_flash_dst=(unsigned long)0x0000e0004u;
 VersNumber.uc[1]=ReadFlashData(addr_flash_dst,0);

 resetWD();

 cntr_1sec=0;

 Line1_L2_Established = Line2_L2_Established = 0;
 FalcError1 = FalcError2 = 0;	/*0 - ok, 1 - AIS,LFA,LMFA,CRC4, 2 - RA */

 LoadProgram=50;

/*************read program version****************************/

 StatusErr.uc=0x0000;
 StatusOut=0;
#ifdef DEBUG_LOADER
 LOG_printf(&MacTrace,"   LOADER AND TESTING\n");
#endif

 resetWD();
 initTimerReels();	      /*incremental double-linked queue*/

 t=&TimerTesting;
 t->nb=0;
 t->period=15000;		  /*period equal 15 second (15000*1ms)*/
 t->isRunning=FALSE;
 t->increment=0;
 t->pFunc=TimeOutTesting;
 TimerStart(&TimerTesting,&Timers1);

 MCBSP_start(hMcbsp2,MCBSP_XMIT_START|MCBSP_RCV_START|MCBSP_SRGR_START,0x300);

#ifdef MBSv1_3
 InitMCP();		//init of 3chips for LEDs control

 MCP_write(BSpower);
#else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,0x00000000);	//power for cells =0
#endif

 StatusErr.uc=0x00;
 StatusErr.s.ste10_yellow = StatusErr.s.ste11_yellow=0;
 StatusErr.s.ste10_red = StatusErr.s.ste11_red=1;
 StatusErr.s.addr=3;	// status bit 0 for E1 line 0

#ifdef MBSv1_3
 MCP_write(E1status);
#else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,StatusErr.uc);
#endif

 TestMem();
 resetWD();

 ChsumLoader();
 resetWD();

 CheckProg();
 resetWD();

 TestFalc();
 resetWD();

/*************read program version****************************/

 resetWD();
 MessageBalance=0;
 initDQ(&MessageQueueL1); /*init queue for message L1*/
 initDQ(&MessageQueueL2); /*init queue for message L2*/
 initIndexMess();         /*init Index for message*/;
 initMessageStack();

 initDQ(&DelicCmd);
 initDQ(&DelicInd);

 resetWD();
 initDQ(&FlagQueue);	  /*init queue for flag*/
 initFlagStack();         /*init Stack for message*/

 t=&TimerHeap;
 t->nb=0;
 t->period=125;	//500;		//my art... /*period equal 0.5 second (500*1ms)*/
 t->isRunning=FALSE;
 t->increment=0;
 t->pFunc=TimeOutHeap;

 TimerStart(&TimerHeap,&Timers1);

 t=&Timer02sec1;
 t->nb=0;
 t->period=100;
 t->isRunning=FALSE;
 t->increment=0;
 t->pFunc=TimeOutHeap;

 t=&Timer03sec1;
 t->nb=0;
 t->period=100;
 t->isRunning=FALSE;
 t->increment=0;
 t->pFunc=TimeOutHeap;

 resetWD();
 InitCard();

 TestEnded=0;

 return;            /*Go to BIOS !!!*/
}
