#if !defined(_OS_QUEUE_H)
#define _OS_QUEUE_H

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif


struct DQE
/* double-linked queue element*/
{
  struct DQE *prev,*next;
};

struct DQ
/* double-linked queue*/
{
  struct DQE *entry,*exit;
  int items;
};

typedef struct DQE* pDQE;
typedef struct DQ* pDQ;

void put(pDQ pointer,pDQE e);
void extract(pDQ p_DQ,pDQE e);
pDQE get(pDQ pointer);
pDQE get_from_tail(pDQ pointer);
void flush(pDQ pointer);
void initDQ(pDQ pointer);


#endif
