#ifndef _DELIC_MON_H
#define _DELIC_MON_H

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

#ifndef _OS_MESSAGE_H
#include "os_message.h"
#endif

#ifndef _OS_QUEUE_H
#include "os_queue.h"
#endif

#ifndef _OS_TIMER_H
#include "os_timer.h"
#endif

enum MonitorState
{
/*
 MonitorIdle,
 MonitorReady,
 MonitorExec
*/
 MonitorIdle,
 MonitorIdentityReceived,
 MonitorSyncEnable
};

void MON_DnProcess(pDelicInfo info);
void Mon_UpProcess(pMessage m);
void Mon_TimeOut(ptimer t);
void Mon_Init(int nb);

struct MonitorChannel
{
 int nb;
 int SyncEnableCount;
/* struct DQ DeferredMessages;*/
 enum MonitorState state;
 struct Timer FailTimer;
 int busy;
};

#endif
