#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <mem.h>
#include <string.h>

#include "os_mt.h"
#include "ccf.h"
#include "os_alltst.h"
#include "c:\CCStudio_v3.3\MyProjects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"

extern LOG_Obj MacTrace;
void Mon_Init(int nb);
void MonManager(pMessage m);
void Init_DelicCI();

int power_bs=0;
int falc_status=0;

extern int GPIOSRsave;
extern struct Message MessageArray[MESSAGE_ARRAY_SIZE];

extern struct DQ MessageQueueL1;
extern struct DQ MessageQueueL2;

void Init_DSS1Lapd(pMessage m);
void InitFALC2256(pMessage m);
void init_DELIC(pMessage m);

extern int ReadHPI;
int PreviousLevelWD=0;

void resetWD();

void Configure()
{
 int k;
 pMessage mo;

/***************init connection with BORODINO ******************/
 mo=AllocMessage(MPH_CONFIGURE_Req,3);
 mo->head.nb=0;		/*0-falc*/

 putw(mo,0); /*slave mode*/	    
 putw(mo,1); /*crc4=1*/
 putw(mo,1); /*long_haul=1*/	    
 mo->head.pFunc=InitFALC2256;
 putMessage(&MessageQueueL1,mo);

 mo=AllocMessage(MDL_CONFIGURE_Req,1);
 mo->head.nb=0;
 putw(mo,1); /*isUserSide*/
 mo->head.pFunc=Init_DSS1Lapd;
 putMessage(&MessageQueueL2,mo);
/***************init connection with BORODINO ******************/
}


void write_power_led(int power,int led)
{
}

void init_MemProc();
void LcManagerConstructor();

extern union Status StatusErr;     /*status after testing hardware*/
extern int StatusOut;

void InitCard()
{
 int i,x,led;
 pMessage mo;

 led=0x0000;

 power_bs=0;
 falc_status=led;

 SetFalcState();
 InitDect(); 
 init_MemProc();

#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"DelicState=Idle\n");
#endif

 Configure();     
 LcManagerConstructor();

 mo=AllocMessage(MPH_CONFIGURE_Req,0);
 mo->head.nb=0;
 mo->head.pFunc=init_DELIC;
 putMessage(&MessageQueueL1,mo);

 Init_DelicCI();

 HWI_enable();                /*may be not do this**/
}

#ifdef MBSv1_3
union MCP23S17_SPI_word MCP_word;
void MCP_reg_write(BYTE chip, BYTE addr, BYTE data);

void MCP_write(BYTE type)
{
 DWORD dummy;

 switch(type)
  {
   case BSpower:	//power off!
    MCP_reg_write(0, 0x9, 0xFF);
	MCP_reg_write(1, 0x9, 0xFF);
	break;
   case TestStatus:
	MCP_reg_write(0, 0x10, (BYTE)((~(StatusErr.uc))>>6));
	break;
   case E1status:
	MCP_reg_write(4, 0x0, (BYTE)((~(StatusErr.uc))&0x3F));
	break;
  }
}

void MCP_reg_write(BYTE chip, BYTE addr, BYTE data)
{
 DWORD dummy;
 
 MCP_word.s.cmd = 0x40 + (chip << 1);
 MCP_word.s.reg_addr = addr;
 MCP_word.s.data = data;
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2, MCP_word.uc);

 while (!MCBSP_rrdy(hMcbsp2));
 dummy = MCBSP_read32(hMcbsp2);
}

DWORD MCP_reg_read(BYTE chip, BYTE addr)
{
 DWORD dummy;
 
 MCP_word.s.cmd = 0x40 + (chip << 1) + 1;
 MCP_word.s.reg_addr = addr;
 MCP_word.s.data = 0;
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2, MCP_word.uc);

 while (!MCBSP_rrdy(hMcbsp2));
 dummy = MCBSP_read32(hMcbsp2);

 return dummy;
}

void InitMCP()
{
 DWORD dummy;
//first chip
 MCP_reg_write(0, 0xa,0xA8);

 MCP_reg_write(0, 0,0);
 MCP_reg_write(0, 1,0);
 MCP_reg_write(0, 2,0);
 MCP_reg_write(0, 3,0);
 MCP_reg_write(0, 4,0);
 MCP_reg_write(0, 6,0);
	MCP_reg_write(0, 9,0);			//!!!!!!!!!!

 MCP_reg_write(0, 0x11,0);
 MCP_reg_write(0, 0x12,0);
 MCP_reg_write(0, 0x13,0);
 MCP_reg_write(0, 0x14,0);
 MCP_reg_write(0, 0x16,0);
 MCP_reg_write(0, 0x19,0);
	MCP_reg_write(0, 0x10,0xFF);	//!!!!!!!!!!!!!!!

//second chip
// MCP_reg_write(1, 0xa,0xA8);	//facultative action?

 MCP_reg_write(1, 0,0);
 MCP_reg_write(1, 1,0);
 MCP_reg_write(1, 2,0);
 MCP_reg_write(1, 3,0);
 MCP_reg_write(1, 4,0);
 MCP_reg_write(1, 6,0);
	MCP_reg_write(1, 9,0);			//!!!!!!!!!!

 MCP_reg_write(1, 0x11,0);
 MCP_reg_write(1, 0x12,0);
 MCP_reg_write(1, 0x13,0);
 MCP_reg_write(1, 0x14,0);
 MCP_reg_write(1, 0x16,0);
 MCP_reg_write(1, 0x19,0);
	MCP_reg_write(1, 0x10,0xFF);	//!!!!!!!!!!!!!!!

//third chip
// MCP_reg_write(4, 0xa,0xA8);

 MCP_reg_write(4, 0,0);
 MCP_reg_write(4, 1,0);
 MCP_reg_write(4, 2,0);
 MCP_reg_write(4, 3,0);
 MCP_reg_write(4, 4,0);
 MCP_reg_write(4, 6,0);
 MCP_reg_write(4, 9,0);
	MCP_reg_write(4, 0x0,0x3F);		//!!!!!!!!!!!!!!!
//P.S.
//GPIOB-bank of MCP23S17 is not used therefore it is not initialized here.

/*
MCP_reg_write(0, 0x9,0xfF);
MCP_reg_write(1, 0x9,0xfF);
	MCP_reg_write(0, 0x10,0);
	MCP_reg_write(1, 0x10,0);
	MCP_reg_write(4, 0x0,0);
dummy=MCP_reg_read(0,0x5);
dummy=MCP_reg_read(1,0x10);
dummy=MCP_reg_read(4,0);
dummy=MCP_reg_read(0,0x10);
 */
}
#endif
