#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

union addr_high
{
 int uc;
 struct
 {
  WORD dummy:12;
  BOOL A19:1;
  BOOL A18:1;
  BOOL A17:1;
  BOOL A16:1;
 }s;
};
void set_sector(int number);
void reset();
void erase_chip();
int erase_sector(int nb, int poll);
/*void erase_sector(int nb);*/
void CnvrtAddrToSctrAndPntrFlash();

/************************SPI FLASH M25P20************************/

enum FlashCmd
{
 WriteStatusRegister=0x1,
 PageProgram,
 ReadDataBytes,
 WriteDisable,
 ReadStatusRegister,
 WriteEnable=0x6,

 ReadDataBytesHighSpeed=0xb,

 ReleaseFromDeep=0xab,
 DeepPowerDown=0xb9,
 BulkErase=0xc7,
 SectorErase=0xd8
};

/************************SPI FLASH M25P20************************/
